diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
similarity index 54%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
index 023d23d46..8544629b5 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPistonHead.java
@@ -9,6 +9,7 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.piston.BlockPistonHead;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
@@ -32,7 +33,6 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         return renderPistonHead(tessellator, block, x, y, z, true);
     }
     public void renderPistonHeadNoCulling(Tessellator tessellator, BlockPistonHead block, int x, int y, int z, boolean flag) {
@@ -61,32 +61,29 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
                 renderBlocks.uvRotateWest = 3;
                 renderBlocks.uvRotateSouth = 3;
                 renderBlocks.uvRotateNorth = 3;
-                block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F);
-                renderStandardBlock(tessellator, block, x, y, z);
-                renderHeadTopBottom(tessellator, (float)x + 0.375F, (float)x + 0.625F, (float)y + headThickness, (float)y + headThickness + f1, (float)z + 0.625F, (float)z + 0.625F, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, (float)x + 0.625F, (float)x + 0.375F, (float)y + headThickness, (float)y + headThickness + f1, (float)z + 0.375F, (float)z + 0.375F, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, (float)x + 0.375F, (float)x + 0.375F, (float)y + headThickness, (float)y + headThickness + f1, (float)z + 0.375F, (float)z + 0.625F, brightness * 0.6F, width);
-                renderHeadTopBottom(tessellator, (float)x + 0.625F, (float)x + 0.625F, (float)y + headThickness, (float)y + headThickness + f1, (float)z + 0.625F, (float)z + 0.375F, brightness * 0.6F, width);
+                renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F), x, y, z);
+                renderHeadTopBottom(tessellator, x + 0.375F, x + 0.625F, y + headThickness, y + headThickness + f1, z + 0.625F, z + 0.625F, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, x + 0.625F, x + 0.375F, y + headThickness, y + headThickness + f1, z + 0.375F, z + 0.375F, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, x + 0.375F, x + 0.375F, y + headThickness, y + headThickness + f1, z + 0.375F, z + 0.625F, brightness * 0.6F, width);
+                renderHeadTopBottom(tessellator, x + 0.625F, x + 0.625F, y + headThickness, y + headThickness + f1, z + 0.625F, z + 0.375F, brightness * 0.6F, width);
                 break;
 
             case UP: // TOP
-                block.setBlockBounds(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
-                renderStandardBlock(tessellator, block, x, y, z);
-                renderHeadTopBottom(tessellator, (float)x + 0.375F, (float)x + 0.625F, (((float)y - headThickness) + 1.0F) - f1, ((float)y - headThickness) + 1.0F, (float)z + 0.625F, (float)z + 0.625F, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, (float)x + 0.625F, (float)x + 0.375F, (((float)y - headThickness) + 1.0F) - f1, ((float)y - headThickness) + 1.0F, (float)z + 0.375F, (float)z + 0.375F, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, (float)x + 0.375F, (float)x + 0.375F, (((float)y - headThickness) + 1.0F) - f1, ((float)y - headThickness) + 1.0F, (float)z + 0.375F, (float)z + 0.625F, brightness * 0.6F, width);
-                renderHeadTopBottom(tessellator, (float)x + 0.625F, (float)x + 0.625F, (((float)y - headThickness) + 1.0F) - f1, ((float)y - headThickness) + 1.0F, (float)z + 0.625F, (float)z + 0.375F, brightness * 0.6F, width);
+                renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
+                renderHeadTopBottom(tessellator, x + 0.375F, x + 0.625F, ((y - headThickness) + 1.0F) - f1, (y - headThickness) + 1.0F, z + 0.625F, z + 0.625F, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, x + 0.625F, x + 0.375F, ((y - headThickness) + 1.0F) - f1, (y - headThickness) + 1.0F, z + 0.375F, z + 0.375F, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, x + 0.375F, x + 0.375F, ((y - headThickness) + 1.0F) - f1, (y - headThickness) + 1.0F, z + 0.375F, z + 0.625F, brightness * 0.6F, width);
+                renderHeadTopBottom(tessellator, x + 0.625F, x + 0.625F, ((y - headThickness) + 1.0F) - f1, (y - headThickness) + 1.0F, z + 0.625F, z + 0.375F, brightness * 0.6F, width);
                 break;
 
             case NORTH: // NORTH
                 renderBlocks.uvRotateSouth = 1;
                 renderBlocks.uvRotateNorth = 2;
-                block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness);
-                renderStandardBlock(tessellator, block, x, y, z);
-                renderHeadNorthSouth(tessellator, (float)x + 0.375F, (float)x + 0.375F, (float)y + 0.625F, (float)y + 0.375F, (float)z + headThickness, (float)z + headThickness + f1, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, (float)x + 0.625F, (float)x + 0.625F, (float)y + 0.375F, (float)y + 0.625F, (float)z + headThickness, (float)z + headThickness + f1, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, (float)x + 0.375F, (float)x + 0.625F, (float)y + 0.375F, (float)y + 0.375F, (float)z + headThickness, (float)z + headThickness + f1, brightness * 0.5F, width);
-                renderHeadNorthSouth(tessellator, (float)x + 0.625F, (float)x + 0.375F, (float)y + 0.625F, (float)y + 0.625F, (float)z + headThickness, (float)z + headThickness + f1, brightness, width);
+                renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness), x, y, z);
+                renderHeadNorthSouth(tessellator, x + 0.375F, x + 0.375F, y + 0.625F, y + 0.375F, z + headThickness, z + headThickness + f1, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, x + 0.625F, x + 0.625F, y + 0.375F, y + 0.625F, z + headThickness, z + headThickness + f1, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, x + 0.375F, x + 0.625F, y + 0.375F, y + 0.375F, z + headThickness, z + headThickness + f1, brightness * 0.5F, width);
+                renderHeadNorthSouth(tessellator, x + 0.625F, x + 0.375F, y + 0.625F, y + 0.625F, z + headThickness, z + headThickness + f1, brightness, width);
                 break;
 
             case SOUTH: // SOUTH
@@ -94,12 +91,11 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
                 renderBlocks.uvRotateNorth = 1;
                 renderBlocks.uvRotateTop = 3;
                 renderBlocks.uvRotateBottom = 3;
-                block.setBlockBounds(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F);
-                renderStandardBlock(tessellator, block, x, y, z);
-                renderHeadNorthSouth(tessellator, (float)x + 0.375F, (float)x + 0.375F, (float)y + 0.625F, (float)y + 0.375F, (((float)z - headThickness) + 1.0F) - f1, ((float)z - headThickness) + 1.0F, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, (float)x + 0.625F, (float)x + 0.625F, (float)y + 0.375F, (float)y + 0.625F, (((float)z - headThickness) + 1.0F) - f1, ((float)z - headThickness) + 1.0F, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, (float)x + 0.375F, (float)x + 0.625F, (float)y + 0.375F, (float)y + 0.375F, (((float)z - headThickness) + 1.0F) - f1, ((float)z - headThickness) + 1.0F, brightness * 0.5F, width);
-                renderHeadNorthSouth(tessellator, (float)x + 0.625F, (float)x + 0.375F, (float)y + 0.625F, (float)y + 0.625F, (((float)z - headThickness) + 1.0F) - f1, ((float)z - headThickness) + 1.0F, brightness, width);
+                renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F), x, y, z);
+                renderHeadNorthSouth(tessellator, x + 0.375F, x + 0.375F, y + 0.625F, y + 0.375F, ((z - headThickness) + 1.0F) - f1, (z - headThickness) + 1.0F, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, x + 0.625F, x + 0.625F, y + 0.375F, y + 0.625F, ((z - headThickness) + 1.0F) - f1, (z - headThickness) + 1.0F, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, x + 0.375F, x + 0.625F, y + 0.375F, y + 0.375F, ((z - headThickness) + 1.0F) - f1, (z - headThickness) + 1.0F, brightness * 0.5F, width);
+                renderHeadNorthSouth(tessellator, x + 0.625F, x + 0.375F, y + 0.625F, y + 0.625F, ((z - headThickness) + 1.0F) - f1, (z - headThickness) + 1.0F, brightness, width);
                 break;
 
             case WEST: // WEST
@@ -107,12 +103,11 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
                 renderBlocks.uvRotateWest = 2;
                 renderBlocks.uvRotateTop = 2;
                 renderBlocks.uvRotateBottom = 1;
-                block.setBlockBounds(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F);
-                renderStandardBlock(tessellator, block, x, y, z);
-                renderHeadEastWest(tessellator, (float)x + headThickness, (float)x + headThickness + f1, (float)y + 0.375F, (float)y + 0.375F, (float)z + 0.625F, (float)z + 0.375F, brightness * 0.5F, width);
-                renderHeadEastWest(tessellator, (float)x + headThickness, (float)x + headThickness + f1, (float)y + 0.625F, (float)y + 0.625F, (float)z + 0.375F, (float)z + 0.625F, brightness, width);
-                renderHeadEastWest(tessellator, (float)x + headThickness, (float)x + headThickness + f1, (float)y + 0.375F, (float)y + 0.625F, (float)z + 0.375F, (float)z + 0.375F, brightness * 0.6F, width);
-                renderHeadEastWest(tessellator, (float)x + headThickness, (float)x + headThickness + f1, (float)y + 0.625F, (float)y + 0.375F, (float)z + 0.625F, (float)z + 0.625F, brightness * 0.6F, width);
+                renderStandardBlock(tessellator, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F), x, y, z);
+                renderHeadEastWest(tessellator, x + headThickness, x + headThickness + f1, y + 0.375F, y + 0.375F, z + 0.625F, z + 0.375F, brightness * 0.5F, width);
+                renderHeadEastWest(tessellator, x + headThickness, x + headThickness + f1, y + 0.625F, y + 0.625F, z + 0.375F, z + 0.625F, brightness, width);
+                renderHeadEastWest(tessellator, x + headThickness, x + headThickness + f1, y + 0.375F, y + 0.625F, z + 0.375F, z + 0.375F, brightness * 0.6F, width);
+                renderHeadEastWest(tessellator, x + headThickness, x + headThickness + f1, y + 0.625F, y + 0.375F, z + 0.625F, z + 0.625F, brightness * 0.6F, width);
                 break;
 
             case EAST: // EAST
@@ -120,16 +115,14 @@ public class BlockModelPistonHead extends BlockModelStandard<BlockPistonHead> {
                 renderBlocks.uvRotateWest = 1;
                 renderBlocks.uvRotateTop = 1;
                 renderBlocks.uvRotateBottom = 2;
-                block.setBlockBounds(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-                renderStandardBlock(tessellator, block, x, y, z);
-                renderHeadEastWest(tessellator, (((float)x - headThickness) + 1.0F) - f1, ((float)x - headThickness) + 1.0F, (float)y + 0.375F, (float)y + 0.375F, (float)z + 0.625F, (float)z + 0.375F, brightness * 0.5F, width);
-                renderHeadEastWest(tessellator, (((float)x - headThickness) + 1.0F) - f1, ((float)x - headThickness) + 1.0F, (float)y + 0.625F, (float)y + 0.625F, (float)z + 0.375F, (float)z + 0.625F, brightness, width);
-                renderHeadEastWest(tessellator, (((float)x - headThickness) + 1.0F) - f1, ((float)x - headThickness) + 1.0F, (float)y + 0.375F, (float)y + 0.625F, (float)z + 0.375F, (float)z + 0.375F, brightness * 0.6F, width);
-                renderHeadEastWest(tessellator, (((float)x - headThickness) + 1.0F) - f1, ((float)x - headThickness) + 1.0F, (float)y + 0.625F, (float)y + 0.375F, (float)z + 0.625F, (float)z + 0.625F, brightness * 0.6F, width);
+                renderStandardBlock(tessellator, AABB.getTemporaryBB(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F), x, y, z);
+                renderHeadEastWest(tessellator, ((x - headThickness) + 1.0F) - f1, (x - headThickness) + 1.0F, y + 0.375F, y + 0.375F, z + 0.625F, z + 0.375F, brightness * 0.5F, width);
+                renderHeadEastWest(tessellator, ((x - headThickness) + 1.0F) - f1, (x - headThickness) + 1.0F, y + 0.625F, y + 0.625F, z + 0.375F, z + 0.625F, brightness, width);
+                renderHeadEastWest(tessellator, ((x - headThickness) + 1.0F) - f1, (x - headThickness) + 1.0F, y + 0.375F, y + 0.625F, z + 0.375F, z + 0.375F, brightness * 0.6F, width);
+                renderHeadEastWest(tessellator, ((x - headThickness) + 1.0F) - f1, (x - headThickness) + 1.0F, y + 0.625F, y + 0.375F, z + 0.625F, z + 0.625F, brightness * 0.6F, width);
                 break;
         }
         resetRenderBlocks();
-        block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         return true;
     }
     private void renderHeadTopBottom(Tessellator tessellator, double xMin, double xMax, double yMin, double yMax, double zMin, double zMax, float brightness, double width)
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
similarity index 85%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
index 958aefa4a..867522d09 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPortal.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockPortal;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
 public class BlockModelPortal<T extends BlockPortal> extends BlockModelTransparent<T> {
@@ -15,19 +16,21 @@ public class BlockModelPortal<T extends BlockPortal> extends BlockModelTranspare
         for (DyeColor color : DyeColor.values()) {
             colors[color.blockMeta] = TextureRegistry.getTexture(rootTexKey + color.colorID);
         }
+        onRenderLayer(1);
     }
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
     {
         if(blockAccess.getBlockId(x, y, z) == block.id)
         {
             return false;
         }
-        return super.shouldSideBeRendered(blockAccess, x, y, z, side);
+        return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
     }
 
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
         return colors[block.fromMetadata(data).blockMeta];
     }
+
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
similarity index 85%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
index e81fabc1e..ed3679f9e 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelPumice.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelPumice<T extends Block> extends BlockModelStandard<T> {
@@ -35,16 +36,16 @@ public class BlockModelPumice<T extends Block> extends BlockModelStandard<T> {
         lavaFlag = true;
         boolean ob = renderBlocks.overbright;
         renderBlocks.overbright = true;
-        block.setBlockBounds(0.005, 0.005, 0.005, 0.995, 0.995, 0.995);
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, LightmapHelper.getLightmapCoord(15, 15));
+        AABB bounds = AABB.getTemporaryBB(0.005, 0.005, 0.005, 0.995, 0.995, 0.995);
+        renderBlockWithBounds(tessellator, bounds, metadata, brightness, alpha, LightmapHelper.getLightmapCoord(15, 15));
 
         renderBlocks.overbright = ob;
         lavaFlag = false;
         if (LightmapHelper.isLightmapEnabled()) {
             lightmapCoordinate = Minecraft.getMinecraft(this).thePlayer.getLightmapCoord(1f);
         }
-        block.setBlockBounds(0, 0, 0, 1, 1, 1);
-        super.renderBlockOnInventory(tessellator, metadata, brightness, alpha, lightmapCoordinate);
+        bounds.set(0, 0, 0, 1, 1, 1);
+        renderBlockWithBounds(tessellator, bounds, metadata, brightness, alpha, lightmapCoordinate);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
similarity index 98%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
index 58563d3e0..a04df889e 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRail.java
@@ -24,7 +24,6 @@ public class BlockModelRail<T extends BlockRail> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         IconCoordinate i1 = getBlockTextureFromSideAndMetadata(Side.BOTTOM, l);
         if(renderBlocks.overrideBlockTexture != null)
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
similarity index 91%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
index 0e0edf690..68e9b1fc2 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRepeater.java
@@ -6,6 +6,7 @@ import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockRepeater;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
 @SuppressWarnings("unchecked")
@@ -18,7 +19,6 @@ public class BlockModelRepeater extends BlockModelStandard<BlockRepeater> {
     }
 
     public boolean render(Tessellator tessellator, int x, int y, int z){
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         int i1 = meta & 3;
 
@@ -42,18 +42,18 @@ public class BlockModelRepeater extends BlockModelStandard<BlockRepeater> {
         }
 
         int j1 = (meta & 0xc) >> 2;
-        renderStandardBlock(tessellator, block, x, y, z);
+        renderStandardBlock(tessellator, block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z), x, y, z);
         resetRenderBlocks();
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
         	int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
-        	if(Block.lightEmission[block.id] > 0) {
+        	if(Blocks.lightEmission[block.id] > 0) {
         		lmc = LightmapHelper.setBlocklightValue(lmc, 15);
         	}
         	tessellator.setLightmapCoord(lmc);
         }else {
     		brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
-    		if(Block.lightEmission[block.id] > 0 || Global.accessor.isFullbrightEnabled()) {
+    		if(Blocks.lightEmission[block.id] > 0 || Global.accessor.isFullbrightEnabled()) {
     			brightness = 1.0f;
     		}
         }
@@ -101,7 +101,7 @@ public class BlockModelRepeater extends BlockModelStandard<BlockRepeater> {
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side)
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side)
     {
         return true;
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
similarity index 61%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
index cd322e604..b25050257 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelRope.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.BlockLanternFirefly;
 import net.minecraft.core.block.BlockRope;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
 public class BlockModelRope<T extends BlockRope>
@@ -30,7 +31,7 @@ extends BlockModelStandard<T> {
             !(!hasBlockNegX && !hasBlockPosX && hasBlockNegY && hasBlockPosY && !hasBlockNegZ && !hasBlockPosZ) &&
             !(!hasBlockNegX && !hasBlockPosX && !hasBlockNegY && !hasBlockPosY && hasBlockNegZ && hasBlockPosZ);
 
-        block.setBlockBounds(0, 0, 0, 1, 1, 1);
+        AABB bounds = AABB.getTemporaryBB(0, 0, 0, 1, 1, 1);
 
         final float ropeThickness = (1 / 16f);
         final float knotThickness = (2 / 16f);
@@ -38,50 +39,47 @@ extends BlockModelStandard<T> {
 
         if (drawKnot)
         {
-            block.setBlockBounds(0.5f - knotThickness, 0.5f - knotThickness, 0.5f - knotThickness, 0.5f + knotThickness, 0.5f + knotThickness, 0.5f + knotThickness);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(0.5f - knotThickness, 0.5f - knotThickness, 0.5f - knotThickness, 0.5f + knotThickness, 0.5f + knotThickness, 0.5f + knotThickness);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
 
         if (hasBlockPosY)
         {
-            block.setBlockBounds(0.5f - ropeThickness, 0.5f, 0.5f - ropeThickness, 0.5f + ropeThickness, 1, 0.5f + ropeThickness);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(0.5f - ropeThickness, 0.5f, 0.5f - ropeThickness, 0.5f + ropeThickness, 1, 0.5f + ropeThickness);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
         if (hasBlockNegY)
         {
-            block.setBlockBounds(0.5f - ropeThickness, 0, 0.5f - ropeThickness, 0.5f + ropeThickness, 0.5f, 0.5f + ropeThickness);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(0.5f - ropeThickness, 0, 0.5f - ropeThickness, 0.5f + ropeThickness, 0.5f, 0.5f + ropeThickness);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
         if (hasBlockPosX)
         {
-            block.setBlockBounds(0.5f, 0.5f - ropeThickness, 0.5f - ropeThickness, 1, 0.5f + ropeThickness, 0.5f + ropeThickness);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(0.5f, 0.5f - ropeThickness, 0.5f - ropeThickness, 1, 0.5f + ropeThickness, 0.5f + ropeThickness);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
         if (hasBlockNegX)
         {
-            block.setBlockBounds(0, 0.5f - ropeThickness, 0.5f - ropeThickness, 0.5f, 0.5f + ropeThickness, 0.5f + ropeThickness);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(0, 0.5f - ropeThickness, 0.5f - ropeThickness, 0.5f, 0.5f + ropeThickness, 0.5f + ropeThickness);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
         if (hasBlockPosZ)
         {
-            block.setBlockBounds(0.5f - ropeThickness, 0.5f - ropeThickness, 0.5f, 0.5f + ropeThickness, 0.5f + ropeThickness, 1);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(0.5f - ropeThickness, 0.5f - ropeThickness, 0.5f, 0.5f + ropeThickness, 0.5f + ropeThickness, 1);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
         if (hasBlockNegZ)
         {
-            block.setBlockBounds(0.5f - ropeThickness, 0.5f - ropeThickness, 0f, 0.5f + ropeThickness, 0.5f + ropeThickness, 0.5f);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(0.5f - ropeThickness, 0.5f - ropeThickness, 0f, 0.5f + ropeThickness, 0.5f + ropeThickness, 0.5f);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
         if (hasFloor){
-            block.setBlockBounds(0.5f - pileWidth, 0,0.5f - pileWidth, 0.5f + pileWidth, knotThickness, 0.5f + pileWidth);
-            renderStandardBlock(tessellator, block, x, y, z);
-            block.setBlockBounds(0.5f - knotThickness, 0,0.5f - knotThickness, 0.5f + knotThickness, ropeThickness * 3, 0.5f + knotThickness);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(0.5f - pileWidth, 0,0.5f - pileWidth, 0.5f + pileWidth, knotThickness, 0.5f + pileWidth);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.5f - knotThickness, 0,0.5f - knotThickness, 0.5f + knotThickness, ropeThickness * 3, 0.5f + knotThickness);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
 
-        block.setBlockBounds(0, 0, 0, 1, 1, 1);
-
-
         return true;
     }
     private boolean canConnect(WorldSource worldSource, int x, int y, int z, Side side){
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
similarity index 68%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
index cee6a8afd..90b615dcb 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSeat.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 
 public class BlockModelSeat<T extends Block> extends BlockModelStandard<T> {
     public BlockModelSeat(Block block) {
@@ -11,20 +12,18 @@ public class BlockModelSeat<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+        AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
 
         setRenderSide(Side.BOTTOM, false); // Set bottom face to not render
-        renderStandardBlock(tessellator, block, x, y, z); // Render seat
+        renderStandardBlock(tessellator, bounds, x, y, z); // Render seat
 
         // Set only the bottom face to render
         renderBlocks.renderBitMask = 0b111111;
         setRenderSide(Side.BOTTOM, true);
-        double minY = block.minY; // Save the minimum bound of the seat
-        block.minY += 0.1875D; // Shift the bottom face up
-        renderStandardBlock(tessellator, block, x, y, z); // Render Seat
+        bounds.minY += 0.1875D; // Shift the bottom face up
+        renderStandardBlock(tessellator, bounds, x, y, z); // Render Seat
 
         // Reset block values
-        block.minY = minY;
         renderBlocks.renderBitMask = 0;
         return true;
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
similarity index 88%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
index dafbaa4ca..f46d77c54 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelSlab.java
@@ -23,4 +23,9 @@ public class BlockModelSlab<T extends BlockSlab> extends BlockModelStandard<T> {
     {
         return BlockModelDispatcher.getInstance().getDispatch(block.modelBlock).getBlockTextureFromSideAndMetadata(side, block.modelBlockMetadata);
     }
+
+    @Override
+    public int renderLayer() {
+        return BlockModelDispatcher.getInstance().getDispatch(block.modelBlock).renderLayer();
+    }
 }
